<?php

/**
 * caco_novedad_reintegro actions.
 *
 * @package    cartera
 * @subpackage caco_novedad_reintegro
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class caco_novedad_reintegroActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    //COMENTARIO DE PRUEBA 20190204

    protected $table_names = array(
        'CACO_NOVEDAD_REINTEGRO',
        'CACO_CONTRATO_V',
        'CACO_TIPO_VALOR_V',
        'TS_TD'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CACO_CONTRATO_V' =>
        array(
            'id_contrato' => 'CACO_NOVEDAD_REINTEGRO'
        ),
        'CACO_TIPO_VALOR_V' =>
        array(
            'tipo_valor' => 'CACO_NOVEDAD_REINTEGRO'
        ),
        'TS_TD, LEFT' =>
        array(
            'id_ts_td-id' => 'CACO_NOVEDAD_REINTEGRO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CACO_NOVEDAD_REINTEGRO' =>
        array(
            'id_novedad_reintegro' => 'id_novedad_reintegro',
            'id_contrato' => 'id_contrato',
            'id_ts_td' => 'id_ts_td',
            'doc_soporte' => 'doc_soporte',
            'tipo_valor' => 'tipo_valor',
            'fecha_novedad' => 'fecha_novedad',
            'valor_reintegro' => 'valor_reintegro',
            'observaciones' => 'observaciones',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'valor_excedente' => 'valor_excedente',
            'id_credito' => 'id_credito'
        ),
        'CACO_CONTRATO_V' =>
        array(
            'id_tipo_contrato' => 'id_tipo_contrato',
            'descripcion' => 'descripcion',
            'codigo' => 'codigo',
            'id_anhos' => 'id_anhos',
            'codigo_anhos' => 'codigo_anhos',
            'fecha_proceso' => 'fecha_proceso',
            'referencia' => 'referencia',
            'referencia_tipo' => 'referencia_tipo',
            'codigo_tipcont' => 'codigo_tipcont',
            'descripcion_tipcont' => 'descripcion_tipcont'
        ),
        'CACO_TIPO_VALOR_V' =>
        array(
            'nombre_tipo_valor' => 'nombre_tipo_valor',
            'orden' => 'orden'
        ),
        'TS_TD' =>
        array(
            'documento' => 'documento',
            'descripcion' => 'descripcion_td'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CACO_NOVEDAD_REINTEGRO' => array(
            'id_novedad_reintegro,a' => array('!=' => array(-1)),
            'id_novedad_reintegro,b' => array('=' => array('id_novedad_reintegro')),
            'id_contrato' => array('=' => array('id_contrato')),
            'id_ts_td' => array('=' => array('id_ts_td')),
            'tipo_valor' => array('=' => array('tipo_valor')),
            'fecha_novedad' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_credito' => array('=' => array('id_credito')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_anhos', 'codigo', 'fecha_novedad', 'orden'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIO DE SUMATORIA - SUM
     *
     */
    protected $summatory_data = array(
        'CACO_NOVEDAD_REINTEGRO' => array(
            'fields' => array('valor_reintegro', 'valor_excedente'),
            'labels' => array('codigo_tipcont,Total'),
            'count' => 'codigo_anhos'
        )
    ); //se especifica por tabla los campos de suma y condiciones de filtro


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_novedad_reintegro'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_novedad_reintegro'); //llave primaria
    protected $field_names = array('id_contrato', 'id_ts_td', 'doc_soporte', 'tipo_valor', 'fecha_novedad',
        'valor_reintegro', 'observaciones', 'fecha_log', 'usuario_log', 'valor_excedente', 'id_credito'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CACO_NOVEDAD_REINTEGRO'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = true; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD
    protected $campo_fecha_sistema_hora = array('fecha_log');

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_novedad_reintegro'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    // Validate

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a validateAdd");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_contrato = $request['id_contrato'];
        $valor_reintegro = $request['valor_reintegro'];
        $valor_reintegro_cont = 0;
        $tipo_valor = $request['tipo_valor'];

        /*
         *  Generar errores en $errors
         */
        /*
         * Valida que el valor de la novedad no supere el valor de aporte colciencias mas otros reintegros
         * Incidente #36558, validacion detallada por tipo de interes, esta se tiene encuetna en el total - 20230926::LAVILA
         */
        //sentencia sql
        $sql = <<<EOD
select
cont.id_contrato,
cont.valor_compania as valor_compania,
sum(novdes.valor_reintegro) as valor_reintegro,

sum( case when novdes.tipo_valor = 'IB' then novdes.valor_reintegro else 0 end ) as valor_reint_ib,
sum( case when novdes.tipo_valor = 'IM' then novdes.valor_reintegro else 0 end ) as valor_reint_im,
sum( case when novdes.tipo_valor = 'IX' then novdes.valor_reintegro else 0 end ) as valor_reint_ix,

MAX( nvl(nov.valor_intereses_banco,0) + nvl(nov.valor_ajuste_banco,0) ) AS suma_intereses_ib,
MAX( nvl(nov.VALOR_INTERESES_MORA,0) + nvl(nov.VALOR_AJUSTE_MORA,0) ) AS suma_intereses_im,
MAX( nvl(nov.INDEXACION,0) + nvl(nov.VALOR_AJUSTE_INDEXACION,0) ) AS suma_intereses_ix,

max( nvl(nov.INDEXACION,0) + nvl(nov.VALOR_AJUSTE_INDEXACION,0) + nvl(nov.VALOR_INTERESES_MORA,0) + nvl(nov.VALOR_INTERESES_BANCO,0) + nvl(nov.VALOR_AJUSTE_BANCO,0) + nvl(nov.VALOR_AJUSTE_MORA,0) ) as suma_intereses

from caco_contrato cont

left join caco_novedad_reintegro novdes
on novdes.id_contrato = cont.id_contrato

left join (

    select
    id_contrato,
    INDEXACION,
    VALOR_INTERESES_MORA,
    VALOR_INTERESES_BANCO,
    VALOR_AJUSTE_BANCO,
    VALOR_AJUSTE_MORA,
    VALOR_AJUSTE_INDEXACION,
    ROW_NUMBER() OVER (
        partition by id_contrato
        ORDER BY id_contrato, FECHA_NOVEDAD desc, ID_NOVEDAD_CONTRATO desc
    ) AS rn
    from caco_novedad_contrato
    where
    id_contrato = $id_contrato
    and firmado = 1

)nov
on nov.id_contrato = cont.id_contrato
and nov.rn = 1

where
cont.id_contrato = $id_contrato

group by
cont.id_contrato,
cont.valor_compania
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0) {

            $valor_compania = $records[0]['valor_compania'];
            $valor_reintegro_cont = $records[0]['valor_reintegro'];
            $valor_reint_ib = $records[0]['valor_reint_ib'];
            $valor_reint_im = $records[0]['valor_reint_im'];
            $valor_reint_ix = $records[0]['valor_reint_ix'];

            $suma_intereses_ib = $records[0]['suma_intereses_ib'];
            $suma_intereses_im = $records[0]['suma_intereses_im'];
            $suma_intereses_ix = $records[0]['suma_intereses_ix'];
            $suma_intereses = $records[0]['suma_intereses'];

            if (($valor_reintegro_cont + $valor_reintegro) > ($valor_compania + $suma_intereses)) {

                $valor_reintegro_text = number_format($valor_reintegro_cont + $valor_reintegro);
                $valor_compania_text = number_format($valor_compania + $suma_intereses);

                $errors['mensaje'] = "El valor($valor_reintegro_text) supera el valor de aporte del contrato($valor_compania_text), verificar.";
                $errors['servicio'] = "caco_novedad_reintegro";
                $logger->info("El valor($valor_reintegro_text) supera el valor de aporte del contrato($valor_compania_text), verificar.");
            }

            //IB-INTERESES BANCARIOS
            if ($tipo_valor == 'IB' && ( ($valor_reint_ib + $valor_reintegro) > $suma_intereses_ib)) {

                $valor_reintegro_text = number_format($valor_reint_ib + $valor_reintegro);
                $valor_sum_text = number_format($suma_intereses_ib);

                $errors['mensaje'] = "El valor($valor_reintegro_text) supera el valor del reintegro de IB($valor_sum_text), verificar.";
                $errors['servicio'] = "caco_novedad_reintegro";
                $logger->info("El valor($valor_reintegro_text) supera el valor del reintegro de IB($valor_sum_text), verificar.");
            }

            //IM-INTERESES MORATORIOS
            if ($tipo_valor == 'IM' && ( ($valor_reint_im + $valor_reintegro) > $suma_intereses_im)) {

                $valor_reintegro_text = number_format($valor_reint_im + $valor_reintegro);
                $valor_sum_text = number_format($suma_intereses_im);

                $errors['mensaje'] = "El valor($valor_reintegro_text) supera el valor del reintegro de IM($valor_sum_text), verificar.";
                $errors['servicio'] = "caco_novedad_reintegro";
                $logger->info("El valor($valor_reintegro_text) supera el valor del reintegro de IM($valor_sum_text), verificar.");
            }

            //IX-INDEXACIÓN
            if ($tipo_valor == 'IX' && ( ($valor_reint_ix + $valor_reintegro) > $suma_intereses_ix)) {

                $valor_reintegro_text = number_format($valor_reint_ix + $valor_reintegro);
                $valor_sum_text = number_format($suma_intereses_ix);

                $errors['mensaje'] = "El valor($valor_reintegro_text) supera el valor del reintegro de IX($valor_sum_text), verificar.";
                $errors['servicio'] = "caco_novedad_reintegro";
                $logger->info("El valor($valor_reintegro_text) supera el valor del reintegro de IX($valor_sum_text), verificar.");
            }
        }


        /**
         * Validacion del desembolso y marca no aporte ctei - 20200708::LAVILA
         * Incidente #36558, validacion detallada por tipo de interes, esta se tiene encuetna en el total - 20230926::LAVILA
         */
        //sentencia sql
        $sql = <<<EOD
select
cont.id_contrato,
cont.valor_compania as valor_compania,
sum(nvl(novdes.valor_desembolso,0)) as valor_desembolso,

MAX( nvl(nov.valor_intereses_banco,0) + nvl(nov.valor_ajuste_banco,0) ) AS suma_intereses_ib,
MAX( nvl(nov.VALOR_INTERESES_MORA,0) + nvl(nov.VALOR_AJUSTE_MORA,0) ) AS suma_intereses_im,
MAX( nvl(nov.INDEXACION,0) + nvl(nov.VALOR_AJUSTE_INDEXACION,0) ) AS suma_intereses_ix,

max( nvl(nov.INDEXACION,0) + nvl(nov.VALOR_AJUSTE_INDEXACION,0) + nvl(nov.VALOR_INTERESES_MORA,0) + nvl(nov.VALOR_INTERESES_BANCO,0) + nvl(nov.VALOR_AJUSTE_BANCO,0) + nvl(nov.VALOR_AJUSTE_MORA,0) ) as suma_intereses

from caco_contrato cont

left join caco_novedad_desembolso novdes
on novdes.id_contrato = cont.id_contrato

left join (

    select
    id_contrato,
    INDEXACION,
    VALOR_INTERESES_MORA,
    VALOR_INTERESES_BANCO,
    VALOR_AJUSTE_BANCO,
    VALOR_AJUSTE_MORA,
    VALOR_AJUSTE_INDEXACION,
    ROW_NUMBER() OVER (
        partition by id_contrato
        ORDER BY id_contrato, FECHA_NOVEDAD desc, ID_NOVEDAD_CONTRATO desc
    ) AS rn
    from caco_novedad_contrato
    where
    id_contrato = $id_contrato
    and firmado = 1

)nov
on nov.id_contrato = cont.id_contrato
and nov.rn = 1

where
cont.id_contrato = $id_contrato
and cont.no_aplica_compania = 0

group by
cont.id_contrato,
cont.valor_compania
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0) {

            $valor_compania = $records[0]['valor_compania'];
            $valor_desembolso = $records[0]['valor_desembolso'];

            $suma_intereses_ib = $records[0]['suma_intereses_ib'];
            $suma_intereses_im = $records[0]['suma_intereses_im'];
            $suma_intereses_ix = $records[0]['suma_intereses_ix'];
            $suma_intereses = $records[0]['suma_intereses'];

            if (($valor_reintegro_cont + $valor_reintegro) > ($valor_desembolso + $suma_intereses)) {

                $valor_reintegro_text = number_format($valor_reintegro_cont + $valor_reintegro);
                $valor_desembolso_text = number_format($valor_desembolso + $suma_intereses);
                $valor_compania_text = number_format($valor_compania);

                $errors['mensaje'] = "El valor($valor_reintegro_text) supera el valor de aporte del desembolso($valor_desembolso_text), verificar.";
                $errors['servicio'] = "caco_novedad_reintegro";
                $logger->info("El valor($valor_reintegro_text) supera el valor de aporte del desembolso($valor_desembolso_text), verificar.");
            }
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a validateRemove");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_novedad_reintegro = $request['id_novedad_reintegro'];

        /*
         *  Generar errores en $errors
         */
        //Valida que no puede borrar todos los reintegros, si ya tiene un credito
        //sentencia sql
        $sql = <<<EOD
select
novdes.*

from CACO_NOVEDAD_REINTEGRO novdes

where
id_novedad_reintegro = $id_novedad_reintegro 
and id_credito is not null 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0) {

            $errors['mensaje'] = "Existen registro de credito; no puede eliminar el reintegro, favor verificar.";
            $errors['servicio'] = "caco_novedad_reintegro";
            $logger->info("Existen registro de credito; no puede eliminar el reintegro, favor verificar.");
        }

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['username'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {

            $id_novedad_reintegro = $request['id_novedad_reintegro'];

            /*
             * Borrar relacion de cont_reintegro - 20200311
             */
            $sql = <<<EOD
delete from caco_nov_cont_reint 
where id_novedad_reintegro = $id_novedad_reintegro 
EOD;
            CN_TABLE::executeSQL($sql);
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
